Application Description: 
		CaretFun.app
		
		APP:	Win API caret functions sample application
		DevEnv:	CTD 1.5.1 PTF 5
		OS:	Windows 98
		Dev:	Lubos Kovacik lk@braso.ch, bbfh@szm.sk
		
		Feel free to use, modify and distribute this sample.
		Let me know about possible bugs or improvements.
		
	Outline Version - 4.0.27
	Design-time Settings
.data VIEWINFO
0000: 6F00000001000000 FFFF01000D004347 5458566965775374 6174650400010000
0020: 0000000000A50000 002C000000020000 0003000000FFFFFF FFFFFFFFFFFCFFFF
0040: FFEBFFFFFFFFFFFF FF000000007C0200 004D010000010000 0001000000010000
0060: 000F4170706C6963 6174696F6E497465 6D00000000
.enddata
		Outline Window State: Normal
		Outline Window Location and Size
.data VIEWINFO
0000: 6600040003002D00 0000000000000000 0000B71E5D0E0500 1D00FFFF4D61696E
0020: 0000000000000000 0000000000000000 0000003B00010000 00000000000000E9
0040: 1E800A00008600FF FF496E7465726E61 6C2046756E637469 6F6E730000000000
0060: 0000000000000000 0000000000003200 0100000000000000 0000E91E800A0000
0080: DF00FFFF56617269 61626C6573000000 0000000000000000 0000000000000000
00A0: 3000010000000000 00000000F51E100D 0000F400FFFF436C 6173736573000000
00C0: 0000000000000000 0000000000000000
.enddata
.data VIEWSIZE
0000: D000
.enddata
			Left: -0.013"
			Top:    0.0"
			Width:  8.013"
			Height: 4.969"
		Options Box Location
.data VIEWINFO
0000: D4180909B80B1A00
.enddata
.data VIEWSIZE
0000: 0800
.enddata
			Visible? Yes
			Left: 4.15"
			Top:    1.885"
			Width:  3.8"
			Height: 2.073"
		Class Editor Location
			Visible? No
			Left: 0.575"
			Top:    0.094"
			Width:  5.063"
			Height: 2.719"
		Tool Palette Location
			Visible? No
			Left: 6.388"
			Top:    0.729"
		Fully Qualified External References? Yes
		Reject Multiple Window Instances? No
		Enable Runtime Checks Of External References? Yes
		Use Release 4.0 Scope Rules? No
	Libraries
		File Include: vtwin.apl
	Global Declarations
		Window Defaults
			Tool Bar
				Display Style? Etched
				Font Name: MS Sans Serif
				Font Size: 8
				Font Enhancement: System Default
				Text Color: System Default
				Background Color: System Default
			Form Window
				Display Style? Etched
				Font Name: MS Sans Serif
				Font Size: 8
				Font Enhancement: System Default
				Text Color: System Default
				Background Color: System Default
			Dialog Box
				Display Style? Etched
				Font Name: MS Sans Serif
				Font Size: 8
				Font Enhancement: System Default
				Text Color: System Default
				Background Color: System Default
			Top Level Table Window
				Font Name: MS Sans Serif
				Font Size: 8
				Font Enhancement: System Default
				Text Color: System Default
				Background Color: System Default
			Data Field
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Multiline Field
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Spin Field
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Background Text
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Pushbutton
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
			Radio Button
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Check Box
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Option Button
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
			Group Box
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Child Table Window
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			List Box
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Combo Box
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Line
				Line Color: Use Parent
			Frame
				Border Color: Use Parent
				Background Color: 3D Face Color
			Picture
				Border Color: Use Parent
				Background Color: Use Parent
		Formats
			Number: 0'%'
			Number: #0
			Number: ###000
			Number: ###000;'($'###000')'
			Date/Time: hh:mm:ss AMPM
			Date/Time: M/d/yy
			Date/Time: MM-dd-yy
			Date/Time: dd-MMM-yyyy
			Date/Time: MMM d, yyyy
			Date/Time: MMM d, yyyy hh:mm AMPM
			Date/Time: MMMM d, yyyy hh:mm AMPM
		External Functions
			Library name: user32.dll
				Function: CreateCaret
					Description:
						! 
								The CreateCaret function creates a new shape for the system caret and assigns ownership of the caret to the specified window.
								The caret shape can be a line, a block, or a bitmap. 
								
									BOOL CreateCaret(
										HWND		hWnd,	// handle to owner window
										HBITMAP	hBitmap,	// handle to bitmap for caret shape
										int		nWidth,	// caret width
										int		nHeight	// caret height
									);
								 
								Parameters
									hWnd		Identifies the window that owns the caret. 
									hBitmap		Identifies the bitmap that defines the caret shape. If this parameter is NULL, the caret is solid. If this parameter
											is (HBITMAP) 1, the caret is gray. If this parameter is a bitmap handle, the caret is the specified bitmap. The bitmap
											handle must have been created by theCreateBitmap,CreateDIBitmap, orLoadBitmap function.If hBitmap is a bitmap handle,
											CreateCaret ignores the nWidth and nHeight parameters; the bitmap defines its own width and height.
									nWidth		Specifies the width of the caret in logical units. If this parameter is zero, the width is set to the system-defined window border
											width. If hBitmap is a bitmap handle, CreateCaret ignores this parameter. 
									nHeight		Specifies the height, in logical units, of the caret. If this parameter is zero, the height is set to the system-defined window
											border height. If hBitmap is a bitmap handle, CreateCaret ignores this parameter.
								Return Values
									If the function succeeds, the return value is nonzero.
									If the function fails, the return value is zero. To get extended error information, callGetLastError. 
								
								Remarks
									The nWidth and nHeight parameters specify the caret's width and height, in logical units; the exact width and height, in pixels, depend on the
									window's mapping mode. CreateCaret automatically destroys the previous caret shape, if any, regardless of the window that owns the caret.
									The caret is hidden until the application calls the ShowCaret function to make the caret visible. The system provides one caret per queue.
									A window should create a caret only when it has the keyboard focus or is active. The window should destroy the caret before losing the
									keyboard focus or becoming inactive.
								
									You can retrieve the width or height of the system's window border by using the GetSystemMetrics function, specifying the SM_CXBORDER
									and SM_CYBORDER values. Using the window border width or height guarantees that the caret will be visible on a high-resolution screen.
								
									Windows CE: Windows CE does not support the hBitmap parameter and it should be set to NULL. Windows CE defaults to a solid caret.
								
								QuickInfo
									Windows NT:	Requires version 3.1 or later.
									Windows:		Requires Windows 95 or later.
									Windows CE:	Requires version 1.0 or later.
									Header:		Declared in winuser.h.
									Import Library:	Use user32.lib.
								
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Window Handle: HWND
						Number: HANDLE
						Number: INT
						Number: INT
				Function: DestroyCaret
					Description:
						! 
								The DestroyCaret function destroys the caret's current shape, frees the caret from the window, and removes the caret from the screen. 
								If the caret shape is based on a bitmap, DestroyCaret does not free the bitmap. 
								
									BOOL DestroyCaret(VOID)
								 
								Parameters
									This function has no parameters.
								
								Return Values
									If the function succeeds, the return value is nonzero.
									If the function fails, the return value is zero. To get extended error information, callGetLastError. 
								
								Remarks
									DestroyCaret destroys the caret only if a window in the current task owns the caret. If a window that is not in the current task owns the
									caret, DestroyCaret does nothing and returns FALSE. The system provides one caret per queue. A window should create a caret only
									when it has the keyboard focus or is active. The window should destroy the caret before losing the keyboard focus or becoming inactive.
								
								QuickInfo
									Windows NT:	Requires version 3.1 or later.
									Windows:		Requires Windows 95 or later.
									Windows CE:	Requires version 1.0 or later.
									Header:		Declared in winuser.h.
									Import Library:	Use user32.lib.
								
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
				Function: FillRect
					Description:
						! 
								The FillRect function fills a rectangle by using the specified brush. This function includes the left and top borders, but excludes the right and bottom
								borders of the rectangle. 
								
								int FillRect(
								
									HDC hDC,		// handle to device context
									CONST RECT *lprc,	// pointer to structure with rectangle
									HBRUSH hbr		// handle to brush
								); 
								
								Parameters
									hDC		Identifies the device context. 
									lprc		Points to a RECT structure that contains the logical coordinates of the rectangle to be filled. 
									hbr		Identifies the brush used to fill the rectangle. 
								
								Return Values
									If the function succeeds, the return value is TRUE.
									If the function fails, the return value is FALSE. To get extended error information, call GetLastError.
								
								Remarks
									The brush identified by the hbr parameter may be either a handle to a logical brush or a color value. If specifying a handle to a logical brush,
									call one of the following functions to obtain the handle: CreateHatchBrush, CreatePatternBrush, or CreateSolidBrush. Additionally, you may
									retrieve a handle to one of the stock brushes by using the GetStockObject function. If specifying a color value for the hbr parameter, it must
									be one of the standard system colors (the value 1 must be added to the chosen color). For example: 
								
										FillRect(hdc, &rect, (HBRUSH) (COLOR_ENDCOLORS+1)); 
								
									For a list of all the standard system colors, see GetSysColor. 
								
									When filling the specified rectangle, FillRect does not include the rectangles right and bottom sides. GDI fills a rectangle up to, but not including,
									the right column and bottom row, regardless of the current mapping mode.
								
					Export Ordinal: 0
					Returns
						Number: INT
					Parameters
						Number: HANDLE
						structPointer
							Number: INT
							Number: INT
							Number: INT
							Number: INT
						Number: HANDLE
				Function: GetCaretBlinkTime
					Description:
						! 
								The GetCaretBlinkTime function returns the elapsed time, in milliseconds, required to invert the caret's pixels.
								The user can set this value using the Control Panel. 
								
									UINT GetCaretBlinkTime(VOID)
								 
								Parameters
									This function has no parameters. 
								
								Return Values
									If the function succeeds, the return value is the blink time, in milliseconds.
									If the function fails, the return value is zero. To get extended error information, callGetLastError. 
								
								QuickInfo
									Windows NT:	Requires version 3.1 or later.
									Windows:		Requires Windows 95 or later.
									Windows CE:	Requires version 1.0 or later.
									Header:		Declared in winuser.h.
									Import Library:	Use user32.lib.
								
					Export Ordinal: 0
					Returns
						Number: UINT
					Parameters
				Function: GetClientRect
					Description:
						! 
								The GetClientRect function retrieves the coordinates of a windows client area.
								The client coordinates specify the upper-left and lower-right corners of the client area.
								Because client coordinates are relative to the upper-left corner of a windows client area, the coordinates of the upper-left corner are (0,0).
								
								BOOL GetClientRect(
								
									HWND hWnd,		// handle of window
									LPRECT lpRect		// address of structure for client coordinates
								); 
								 
								Parameters:
									hWnd 		Identifies the window whose client coordinates are to be retrieved.
									lpRect 		Points to a RECT structure that receives the client coordinates. The left and top members are zero.
											The right and bottom members contain the width and height of the window.
								
								Return Values:
									If the function succeeds, the return value is nonzero.
									If the function fails, the return value is zero. To get extended error information, call GetLastError.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Window Handle: HWND
						structPointer
							Receive Number: LONG
							Receive Number: LONG
							Receive Number: LONG
							Receive Number: LONG
				Function: GetDC
					Description:
						! 
								The GetDC function retrieves a handle of a display device context (DC) for the client area of the specified window.
								The display device context can be used in subsequent GDI functions to draw in the client area of the window.
								
								This function retrieves a common, class, or private device context depending on the class style specified for the specified window.
								For common device contexts, GetDC assigns default attributes to the device context each time it is retrieved.
								For class and private device contexts, GetDC leaves the previously assigned attributes unchanged.
								
								HDC GetDC(
								
									HWND hWnd		// handle of window 
								); 
								 
								Parameters:
									hWnd 		Identifies the window whose device context is to be retrieved.
								
								Return Values:
									If the function succeeds, the return value identifies the device context for the given windows client area.
									If the function fails, the return value is NULL.
								
								Remarks:
									After painting with a common device context, the ReleaseDC function must be called to release the device context.
									Class and private device contexts do not have to be released. The number of device contexts is limited only by available memory.
								
					Export Ordinal: 0
					Returns
						Number: HANDLE
					Parameters
						Window Handle: HWND
				Function: GetSysColor
					Description:
						! 
								The GetSysColor function retrieves the current color of the specified display element. Display elements are the parts of a window and the Windows display
								that appear on the system display screen. 
								
								DWORD GetSysColor(
								
									int nIndex		// display element
								); 
								
								Parameters
									nIndex		Specifies the display element whose color is to be retrieved. This parameter must be one of the following values:
								
											Value			Meaning 
								
											COLOR_3DDKSHADOW		Dark shadow for three-dimensional display elements.
											COLOR_3DFACE,
											COLOR_BTNFACE			Face color for three-dimensional display elements.
											COLOR_3DHILIGHT,
											COLOR_3DHIGHLIGHT,
											COLOR_BTNHILIGHT,
											COLOR_BTNHIGHLIGHT		Highlight color for three-dimensional display elements (for edges facing the light source.) 
											COLOR_3DLIGHT			Light color for three-dimensional display elements (for edges facing the light source.)
											COLOR_3DSHADOW,
											COLOR_BTNSHADOW		Shadow color for three-dimensional display elements (for edges facing away from the
															light source).
											COLOR_ACTIVEBORDER		Active window border.
											COLOR_ACTIVECAPTION		Active window caption.
											COLOR_APPWORKSPACE		Background color of multiple document interface (MDI) applications.
											COLOR_BACKGROUND,
											COLOR_DESKTOP			Desktop.
											COLOR_BTNTEXT			Text on push buttons.
											COLOR_CAPTIONTEXT		Text in caption, size box, and scroll bar arrow box.
											COLOR_GRAYTEXT		Grayed (disabled) text. This color is set to 0 if the current display driver does not support a
															solid gray color. 
								 			COLOR_HIGHLIGHT		Item(s) selected in a control.
											COLOR_HIGHLIGHTTEXT		Text of item(s) selected in a control.
											COLOR_INACTIVEBORDER		Inactive window border.
											COLOR_INACTIVECAPTION		Inactive window caption.
											COLOR_INACTIVECAPTIONTEXT	Color of text in an inactive caption. 
											COLOR_INFOBK			Background color for tooltip controls.
											COLOR_INFOTEXT		Text color for tooltip controls.
											COLOR_MENU			Menu background.
											COLOR_MENUTEXT		Text in menus.
											COLOR_SCROLLBAR		Scroll bar gray area.
											COLOR_WINDOW			Window background.
											COLOR_WINDOWFRAME		Window frame.
											COLOR_WINDOWTEXT		Text in windows.
								 
								Return Values
									If the function succeeds, the return value is the red, green, blue (RGB) color value that specifies the color of the given element. 
								
								Remarks
									System colors for monochrome displays are usually interpreted as shades of gray. 
								
					Export Ordinal: 0
					Returns
						Number: DWORD
					Parameters
						Number: INT
				Function: GetWindow
					Description:
						! 
								The GetWindow function retrieves the handle of a window that has the specified relationship (Z order or owner) to the specified window.
								
								HWND GetWindow(
								
									HWND hWnd,		// handle of original window 
									UINT uCmd		// relationship flag
								); 
								 
								Parameters:
									hWnd 		Identifies a window. The window handle retrieved is relative to this window,
											based on the value of the uCmd parameter.
									uCmd 		Specifies the relationship between the specified window and the window whose handle is to be retrieved.
											This parameter can be one of the following values:
								
											Value 		 	Meaning
											GW_CHILD 		The retrieved handle identifies the child window at the top of the Z order,
														if the specified window is a parent window; otherwise, the retrieved handle is NULL.
														The function examines only child windows of the specified window.
														It does not examine descendant windows.
											GW_HWNDFIRST 		The retrieved handle identifies the window of the same type that is highest in the Z
														order. If the specified window is a topmost window, the handle identifies the topmost
														window that is highest in the Z order. If the specified window is a top-level window,
														the handle identifies the top-level window that is highest in the Z order.
														If the specified window is a child window, the handle identifies the sibling window
														that is highest in the Z order.
											GW_HWNDLAST 		The retrieved handle identifies the window of the same type that is lowest in the Z order.
														If the specified window is a topmost window, the handle identifies the topmost window
														that is lowest in the Z order. If the specified window is a top-level window, the handle
														identifies the top-level window that is lowest in the Z order. If the specified window is a
														child window, the handle identifies the sibling window that is lowest in the Z order.
											GW_HWNDNEXT 		The retrieved handle identifies the window below the specified window in the Z order.
														If the specified window is a topmost window, the handle identifies the topmost window
														below the specified window. If the specified window is a top-level window, the handle
														identifies the top-level window below the specified window. If the specified window is a
														child window, the handle identifies the sibling window below the specified window.
											GW_HWNDPREV 		The retrieved handle identifies the window above the specified window in the Z order.
														If the specified window is a topmost window, the handle identifies the topmost window
														above the specified window. If the specified window is a top-level window, the handle
														identifies the top-level window above the specified window. If the specified window is
														a child window, the handle identifies the sibling window above the specified window.
											GW_OWNER 		The retrieved handle identifies the specified windows owner window, if any.
								
								Return Values:
									If the function succeeds, the return value is a window handle.
									If no window exists with the specified relationship to the specified window, the return value is NULL.
					Export Ordinal: 0
					Returns
						Window Handle: HWND
					Parameters
						Window Handle: HWND
						Number: UINT
				Function: GetWindowLongA
					Description:
						! 
								The GetWindowLong function retrieves information about the specified window.
								The function also retrieves the 32-bit (long) value at the specified offset into the extra window memory of a window.
								
								LONG GetWindowLong(
								
									HWND hWnd,			// handle of window
									int nIndex				// offset of value to retrieve
								);  
								
								Parameters:
									hWnd 		Identifies the window and, indirectly, the class to which the window belongs.
									nIndex 		Specifies the zero-based offset to the value to be retrieved. Valid values are in the range zero through the number of bytes of
											extra window memory, minus four; for example, if you specified 12 or more bytes of extra memory, a value of 8 would be an
											index to the third 32-bit integer. To retrieve any other value, specify one of the following values:
								
											Value 			Action
											GWL_EXSTYLE 		Retrieves the extended window styles.
											GWL_STYLE 		Retrieves the window styles.
											GWL_WNDPROC 		Retrieves the address of the window procedure, or a handle representing the address of the
														window procedure. You must use the CallWindowProc function to call the window procedure.
											GWL_HINSTANCE 	Retrieves the handle of the application instance.
											GWL_HWNDPARENT 	Retrieves the handle of the parent window, if any.
											GWL_ID 			Retrieves the identifier of the window.
											GWL_USERDATA 		Retrieves the 32-bit value associated with the window. Each window has a corresponding
														32-bit value intended for use by the application that created the window.
								
											The following values are also available when the hWnd parameter identifies a dialog box:
								
											Value 			Action
											DWL_DLGPROC 		Retrieves the address of the dialog box procedure, or a handle representing the address of the
														dialog box procedure. You must use the CallWindowProc function to call the dialog box procedure.
											DWL_MSGRESULT 	Retrieves the return value of a message processed in the dialog box procedure.
											DWL_USER 		Retrieves extra information private to the application, such as handles or pointers.
								 
								Return Values:
									If the function succeeds, the return value is the requested 32-bit value.
									If the function fails, the return value is zero. To get extended error information, call GetLastError.
								
								Remarks:
									Reserve extra window memory by specifying a nonzero value in the cbWndExtra member of the WNDCLASS structure used with the
									RegisterClass function.
					Export Ordinal: 0
					Returns
						Number: LONG
					Parameters
						Window Handle: HWND
						Number: INT
				Function: HideCaret
					Description:
						! 
								The HideCaret function removes the caret from the screen. Hiding a caret does not destroy its current shape or invalidate the insertion point. 
								
									BOOL HideCaret(
								
										HWND hWnd   // handle to the window with the caret
									);
								 
								Parameters
									hWnd	Identifies the window that owns the caret. If this parameter is NULL, HideCaret searches the current task for the window that
										owns the caret. 
								Return Values
									If the function succeeds, the return value is nonzero.
									If the function fails, the return value is zero. To get extended error information, callGetLastError.
								
								Remarks
									HideCaret hides the caret only if the specified window owns the caret. If the specified window does not own the caret, HideCaret does
									nothing and returns FALSE. Hiding is cumulative. If your application calls HideCaret five times in a row, it must also call ShowCaret five times
									before the caret is displayed.
								
								QuickInfo
									Windows NT:	Requires version 3.1 or later.
									Windows:		Requires Windows 95 or later.
									Windows CE:	Requires version 1.0 or later.
									Header:		Declared in winuser.h.
									Import Library:	Use user32.lib.
								
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Window Handle: HWND
				Function: ReleaseDC
					Description:
						! 
								The ReleaseDC function releases a device context (DC), freeing it for use by other applications.
								The effect of the ReleaseDC function depends on the type of device context. It frees only common and window device contexts.
								It has no effect on class or private device contexts.
								
								int ReleaseDC(
								
									HWND hWnd,		// handle of window 
									HDC hDC			// handle of device context 
								 ); 
								 
								Parameters:
									hWnd 		Identifies the window whose device context is to be released.
									hDC 		Identifies the device context to be released.
								
								Return Values:
									The return value specifies whether the device context is released. If the device context is released, the return value is 1.
									If the device context is not released, the return value is zero.
								
								Remarks:
									The application must call the ReleaseDC function for each call to the GetWindowDC function and for each call to the GetDC function that retrieves
									a common device context. An application cannot use the ReleaseDC function to release a device context that was created by calling the
									CreateDC function; instead, it must use the DeleteDC function.
								
					Export Ordinal: 0
					Returns
						Number: INT
					Parameters
						Window Handle: HWND
						Number: HANDLE
				Function: SetCaretBlinkTime
					Description:
						! 
								The SetCaretBlinkTime function sets the caret blink time to the specified number of milliseconds. The blink time is the elapsed time, in milliseconds,
								required to invert the caret's pixels.
								
									BOOL SetCaretBlinkTime(
								
										UINT	uMSeconds	// blink time, in milliseconds
									);
								 
								Parameters
									uMSeconds	Specifies the new blink time, in milliseconds.
								
								Return Values
									If the function succeeds, the return value is nonzero.
									If the function fails, the return value is zero. To get extended error information, callGetLastError. 
								
								Remarks
									The user can set the blink time using the Control Panel. Applications should respect the setting that the user has chosen. The SetCaretBlinkTime
									function should only be used by application that allow the user to set the blink time, such as a Control Panel applet.
								
									If you change the blink time, subsequently activated applications will use the modified blink time, even if you restore the previous blink time when
									you lose the keyboard focus or become inactive. This is due to the multithreaded environment, where deactivation of your application is not
									synchronized with the activation of another application. This feature allows the system to activate another application even if the current
									application is hung.
								
									Windows CE: In Windows CE, changing the caret blink time in one application will not affect the blink time in subsequently loaded applications.
								
								QuickInfo
									Windows NT:	Requires version 3.1 or later.
									Windows:		Requires Windows 95 or later.
									Windows CE:	Requires version 1.0 or later.
									Header:		Declared in winuser.h.
									Import Library:	Use user32.lib.
								
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Number: UINT
				Function: ShowCaret
					Description:
						! 
								The ShowCaret function makes the caret visible on the screen at the caret's current position. When the caret becomes visible, it begins flashing automatically.
								
								BOOL ShowCaret(
								
									HWND hWnd   // handle of window with caret
								);
								 
								Parameters
									hWnd	Identifies the window that owns the caret. If this parameter is NULL, ShowCaret searches the current task for the window
										that owns the caret.
								Return Values
									If the function succeeds, the return value is nonzero.
									If the function fails, the return value is zero. To get extended error information, callGetLastError. 
								
								Remarks
									ShowCaret shows the caret only if the specified window owns the caret, the caret has a shape, and the caret has not been hidden two or more
									times in a row. If one or more of these conditions is not met, ShowCaret does nothing and returns FALSE. 
									Hiding is cumulative. If your application calls HideCaret five times in a row, it must also call ShowCaret five times before the caret reappears.
									The system provides one caret per queue. A window should create a caret only when it has the keyboard focus or is active. The window should
									destroy the caret before losing the keyboard focus or becoming inactive.
								
								QuickInfo
									Windows NT:	Requires version 3.1 or later.
									Windows:		Requires Windows 95 or later.
									Windows CE:	Requires version 1.0 or later.
									Header:		Declared in winuser.h.
									Import Library:	Use user32.lib.
								
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Window Handle: HWND
			Library name: gdi32.dll
				Function: CreateCompatibleBitmap
					Description:
						! 
								The CreateCompatibleBitmap function creates a bitmap compatible with the device that is associated with the specified device context.
								
								HBITMAP CreateCompatibleBitmap(
								
									HDC hdc,		// handle to device context
									int nWidth,	// width of bitmap, in pixels
									int nHeight	// height of bitmap, in pixels
								);
								
								Parameters
									hdc	Handle to a device context.
									nWidth	Specifies the bitmap width, in pixels.
									nHeight	Specifies the bitmap height, in pixels.
								
								Return Values
									If the function succeeds, the return value is a handle to the bitmap.
									If the function fails, the return value is NULL.
								
									Windows NT: To get extended error information, callGetLastError.
								
								Remarks
									The color format of the bitmap created by the CreateCompatibleBitmap function matches the color format of the device identified by
									the hdc parameter. This bitmap can be selected into any memory device context that is compatible with the original device.
								
									Because memory device contexts allow both color and monochrome bitmaps, the format of the bitmap returned by the
									CreateCompatibleBitmap function differs when the specified device context is a memory device context. However, a compatible bitmap
									that was created for a nonmemory device context always possesses the same color format and uses the same color palette as the
									specified device context.
								
									If an application sets the nWidth or nHeight parameters to zero, CreateCompatibleBitmap returns the handle to a 1- by 1-pixel,
									monochrome bitmap.
								
									If a DIB section, which is a bitmap created by the CreateDIBSection function, is selected into the device context identified by the
									hdc parameter, CreateCompatibleBitmap creates a DIB section.
								
									When you no longer need the bitmap, call the DeleteObject function to delete it.
								
								QuickInfo
									Windows NT:	Requires version 3.1 or later.
									Windows:		Requires Windows 95 or later.
									Windows CE:	Requires version 1.0 or later.
									Header:		Declared in wingdi.h.
									Import Library:	Use gdi32.lib.
								
					Export Ordinal: 0
					Returns
						Number: HANDLE
					Parameters
						Number: HANDLE
						Number: INT
						Number: INT
				Function: CreateCompatibleDC
					Description:
						! 
								The CreateCompatibleDC function creates a memory device context (DC) compatible with the specified device.
								
								HDC CreateCompatibleDC(
								
									HDC hdc		// handle to memory device context 
								); 
								 
								Parameters:
									hdc 		Identifies the device context. If this handle is NULL, the function creates a memory device context compatible
											with the applications current screen.
								
								Return Values:
									If the function succeeds, the return value is the handle to a memory device context.
									If the function fails, the return value is NULL.
								
								Remarks:
									Before an application can use a memory device context for drawing operations, it must select a bitmap of the correct width and height into
									the device context. Once a bitmap has been selected, the device context can be used to prepare images that will be copied to the screen or printed.
								
									The CreateCompatibleDC function can only be used with devices that support raster operations. An application can determine whether a device
									supports these operations by calling the GetDeviceCaps function.
								
									When you no longer need the memory device context, call the DeleteDC function to delete it.
								
					Export Ordinal: 0
					Returns
						Number: HANDLE
					Parameters
						Number: HANDLE
				Function: CreatePen
					Description:
						! 
								The CreatePen function creates a logical pen that has the specified style, width, and color. The pen can subsequently be selected into a device
								context and used to draw lines and curves. 
								
								HPEN CreatePen(
								
									int fnPenStyle,		// pen style
									int nWidth,		// pen width
									COLORREF crColor		// pen color
								);
								
								Parameters
									fnPenStyle	Specifies the pen style. It can be any one of the following values:
								
											Style			Description
								
											PS_SOLID		Pen is solid.
											PS_DASH		Pen is dashed. This style is valid only when the pen width is one or less in device units. 
											PS_DOT			Pen is dotted. This style is valid only when the pen width is one or less in device units.
											PS_DASHDOT		Pen has alternating dashes and dots. This style is valid only when the pen width is one or
														less in device units.
											PS_DASHDOTDOT	Pen has alternating dashes and double dots. This style is valid only when the pen width is
														one or less in device units.
											PS_NULL		Pen is invisible.
											PS_INSIDEFRAME		Pen is solid. When this pen is used in any graphics device interface (GDI) drawing function
														that takes a bounding rectangle, the dimensions of the figure are shrunk so that it fits entirely
														in the bounding rectangle, taking into account the width of the pen. This applies only to
														geometric pens.
								 
									nWidth		Specifies the width of the pen, in logical units. If nWidth is zero, the pen is a single pixel wide, regardless of the current
											transformation.
									crColor		Specifies a color reference for the pen color.
								
								Return Values
									If the function succeeds, the return value is a handle that identifies a logical pen.
									If the function fails, the return value is NULL.
								
								Remarks
									After an application creates a logical pen, it can select that pen into a device context by calling the SelectObject function. After a pen is selected
									into a device context, it can be used to draw lines and curves.
								
									If the value specified by the nWidth parameter is zero, a line drawn with the created pen will always be a single pixel wide regardless of the current
									transformation. 
								
									If the value specified by nWidth is greater than 1, the fnPenStyle parameter must be PS_NULL, PS_SOLID, or PS_INSIDEFRAME. 
								
									If the value specified by nWidth is greater than 1 and fnPenStyle is PS_INSIDEFRAME, the line associated with the pen is drawn inside the frame
									of all primitives except polygons and polylines.
								
									If the value specified by nWidth is greater than 1, fnPenStyle is PS_INSIDEFRAME, and the color specified by the crColor parameter does not match
									one of the entries in the logical palette, Windows draws lines by using a dithered color. Dithered colors are not available with solid pens.
								
									When you no longer need the pen, call the DeleteObject function to delete it.
								
					Export Ordinal: 0
					Returns
						Number: HANDLE
					Parameters
						Number: INT
						Number: INT
						Number: LONG
				Function: CreateSolidBrush
					Description:
						! 
								The CreateSolidBrush function creates a logical brush that has the specified solid color.
								
								HBRUSH CreateSolidBrush(
								
									COLORREF crColor		// brush color value
								); 
								 
								Parameters:
									crColor 		Specifies the color of the brush.
								
								Return Values:
									If the function succeeds, the return value identifies a logical brush.
									If the function fails, the return value is NULL.
								
								Remarks:
									A solid brush is a bitmap that the system uses to paint the interiors of filled shapes.
								
									After an application creates a brush by calling CreateSolidBrush, it can select that brush into any device
									context by calling the SelectObject function.
								
									ICM: No color is done at brush creation. However, color management will be performed when the brush is selected into an ICM-enabled device context.
								
					Export Ordinal: 0
					Returns
						Number: HANDLE
					Parameters
						Number: LONG
				Function: DeleteDC
					Description:
						! 
								The DeleteDC function deletes the specified device context (DC).
								
								BOOL DeleteDC(
								
									HDC hdc		// handle to device context
								);
								 
								Parameters:
									hdc 		Identifies the device context.
								
								Return Values:
									If the function succeeds, the return value is nonzero.
									If the function fails, the return value is zero.
								
								Remarks:
									An application must not delete a device context whose handle was obtained by calling the GetDC function. Instead, it must call the
									ReleaseDC function to free the device context.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Number: HANDLE
				Function: DeleteObject
					Description:
						! 
								The DeleteObject function deletes a logical pen, brush, font, bitmap, region, or palette, freeing all system resources associated with the object.
								After the object is deleted, the specified handle is no longer valid.
								
								BOOL DeleteObject(
								
									HGDIOBJ hObject		// handle to graphic object
								); 
								 
								Parameters:
									hObject		Identifies a logical pen, brush, font, bitmap, region, or palette.
								
								Return Values:
									If the function succeeds, the return value is nonzero.
									If the specified handle is not valid or is currently selected into a device context, the return value is zero.
								
								Remarks:
									Do not delete a drawing object (pen or brush) while it is still selected into a device context.
									When a pattern brush is deleted, the bitmap associated with the brush is not deleted. The bitmap must be deleted independently.
								
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Number: HANDLE
				Function: GetTextMetricsA
					Description:
						! 
								The GetTextMetrics function fills the specified buffer with the metrics for the currently selected font. 
								
									BOOL GetTextMetrics(
										HDC		hdc,	// handle to device context
										LPTEXTMETRIC	lptm	// pointer to text metrics structure
									);
								 
								Parameters
									hdc	Handle to the device context. 
									lptm	Pointer to the TEXTMETRIC structure that is to receive the metrics.
								
									The TEXTMETRIC structure contains basic information about a physical font. All sizes are given in logical units; that is,
									they depend on the current mapping mode of the display context.
								
									typedef struct tagTEXTMETRIC { // tm
										    LONG tmHeight;
										    LONG tmAscent;
										    LONG tmDescent;
										    LONG tmInternalLeading; 
										    LONG tmExternalLeading; 
										    LONG tmAveCharWidth; 
										    LONG tmMaxCharWidth; 
										    LONG tmWeight; 
										    LONG tmOverhang; 
										    LONG tmDigitizedAspectX; 
										    LONG tmDigitizedAspectY; 
										    BCHAR tmFirstChar; 
										    BCHAR tmLastChar; 
										    BCHAR tmDefaultChar; 
										    BCHAR tmBreakChar; 
										    BYTE tmItalic; 
										    BYTE tmUnderlined; 
										    BYTE tmStruckOut; 
										    BYTE tmPitchAndFamily; 
										    BYTE tmCharSet; 
									} TEXTMETRIC;
								 
									Members
										tmHeight		Specifies the height (ascent + descent) of characters. 
										tmAscent		Specifies the ascent (units above the base line) of characters. 
										tmDescent	Specifies the descent (units below the base line) of characters. 
										tmInternalLeading	Specifies the amount of leading (space) inside the bounds set by the tmHeight member.
												Accent marks and other diacritical characters may occur in this area. The designer may set this member to zero. 
										tmExternalLeading	Specifies the amount of extra leading (space) that the application adds between rows. Since this area is outside
												the font, it contains no marks and is not altered by text output calls in either OPAQUE or TRANSPARENT mode.
												The designer may set this member to zero.
										tmAveCharWidth	Specifies the average width of characters in the font (generally defined as the width of the letter x). This value
												does not include the overhang required for bold or italic characters.
										tmMaxCharWidth	Specifies the width of the widest character in the font.
										tmWeight		Specifies the weight of the font.
										tmOverhang	Specifies the extra width per string that may be added to some synthesized fonts. When synthesizing some attributes,
												such as bold or italic, graphics device interface (GDI) or a device may have to add width to a string on both a per
												character and per-string basis. For example, GDI makes a string bold by expanding the spacing of each character
												and overstriking by an offset value; it italicizes a font by shearing the string. In either case, there is an overhang past
												the basic string. For bold strings, the overhang is the distance by which the overstrike is offset. For italic strings, the
												overhang is the amount the top of the font is sheared past the bottom of the font. The tmOverhang member enables the
												application to determine how much of the character width returned by a GetTextExtentPoint32 function call on a single
												character is the actual character width and how much is the per-string extra width. The actual width is the extent minus
												the overhang.
										tmDigitizedAspectX	Specifies the horizontal aspect of the device for which the font was designed.
										tmDigitizedAspectY	Specifies the vertical aspect of the device for which the font was designed. The ratio of the tmDigitizedAspectX
												and tmDigitizedAspectY members is the aspect ratio of the device for which the font was designed.
										tmFirstChar	Specifies the value of the first character defined in the font. 
										tmLastChar	Specifies the value of the last character defined in the font. 
										tmDefaultChar	Specifies the value of the character to be substituted for characters not in the font. 
										tmBreakChar	Specifies the value of the character that will be used to define word breaks for text justification. 
										tmItalic		Specifies an italic font if it is nonzero. 
										tmUnderlined	Specifies an underlined font if it is nonzero. 
										tmStruckOut	Specifies a strikeout font if it is nonzero. 
										tmPitchAndFamily	Specifies information about the pitch, the technology, and the family of a physical font. The four low-order bits of this
												member specify information about the pitch and the technology of the font. A constant is defined for each of the four bits:
								
												Constant			Meaning
								
												TMPF_FIXED_PITCH	If this bit is set the font is a variable pitch font. If this bit is clear the font is a fixed pitch font.
															Note very carefully that those meanings are the opposite of what the constant name implies. 
												TMPF_VECTOR		If this bit is set the font is a vector font.
												TMPF_TRUETYPE		If this bit is set the font is a TrueType font. 
												TMPF_DEVICE		If this bit is set the font is a device font.
								
												An application should carefully test for qualities encoded in these low-order bits, making no arbitrary assumptions. For example,
												besides having their own bits set, TrueType and PostScript fonts set the TMPF_VECTOR bit. A monospace bitmap font has
												all of these low-order bits clear; a proportional bitmap font sets the TMPF_FIXED_PITCH bit. A Postscript printer device font
												sets the TMPF_DEVICE, TMPF_VECTOR, and TMPF_FIXED_PITCH bits.
								
												The four high-order bits of tmPitchAndFamily designate the font's font family. An application can use the value 0xF0 and the
												bitwise AND operator to mask out the four low-order bits of tmPitchAndFamily, thus obtaining a value that can be directly
												compared with font family names to find an identical match. For information about font families, see the description of the
												LOGFONT structure.
								
										tmCharSet	Specifies the character set of the font. The character set can be one of the following values:
								    
								
												ANSI_CHARSET			DEFAULT_CHARSET
												SYMBOL_CHARSET		SHIFTJIS_CHARSET
												HANGUL_CHARSET		GB2312_CHARSET
												CHINESEBIG5_CHARSET		OEM_CHARSET
												JOHAB_CHARSET			HEBREW_CHARSET
												ARABIC_CHARSET		GREEK_CHARSET
												TURKISH_CHARSET		VIETNAMESE_CHARSET
												THAI_CHARSET			EASTEUROPE_CHARSET
												RUSSIAN_CHARSET		MAC_CHARSET
												BALTIC_CHARSET
								
									QuickInfo (TEXTMETRIC)
										 Windows NT:	Requires version 3.1 or later.
										 Windows:	Requires Windows 95 or later.
										 Windows CE:	Requires version 1.0 or later.
										 Header:		Declared in wingdi.h.
										 Unicode:		Defined as Unicode and ANSI structures.
								
								Return Values
									If the function succeeds, the return value is nonzero.
									If the function fails, the return value is zero. 
								
									Windows NT: To get extended error information, callGetLastError. 
								
								Remarks
									Windows CE: For any given font, the text metric values in Windows CE will not necessarily match the text metric values in Windows desktop platforms. 
								
								QuickInfo
									 Windows NT:	Requires version 3.1 or later.
									 Windows:	Requires Windows 95 or later.
									 Windows CE:	Requires version 1.0 or later.
									 Header:		Declared in wingdi.h.
									 Import Library:	Use gdi32.lib
									 Unicode:		Implemented as Unicode and ANSI versions on Windows NT
								
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Number: HANDLE
						structPointer
							Receive Number: LONG
							Receive Number: LONG
							Receive Number: LONG
							Receive Number: LONG
							Receive Number: LONG
							Receive Number: LONG
							Receive Number: LONG
							Receive Number: LONG
							Receive Number: LONG
							Receive Number: LONG
							Receive Number: LONG
							Receive Number: BYTE
							Receive Number: BYTE
							Receive Number: BYTE
							Receive Number: BYTE
							Receive Number: BYTE
							Receive Number: BYTE
							Receive Number: BYTE
							Receive Number: BYTE
							Receive Number: BYTE
				Function: LineTo
					Description:
						! 
								The LineTo function draws a line from the current position up to, but not including, the specified point. 
								
								BOOL LineTo(
								
									HDC hdc,		// device context handle
									int nXEnd,	// x-coordinate of lines ending point
									int nYEnd		// y-coordinate of lines ending point
								);
								
								Parameters
									hdc	Identifies a device context.
									nXEnd	Specifies the x-coordinate of the lines ending point.
									nYEnd	Specifies the y-coordinate of the lines ending point.
								
								Return Values
									If the function succeeds, the return value is nonzero.
									If the function fails, the return value is zero.
								
								Remarks
									The coordinates of the lines ending point are specified in logical units.
									The line is drawn by using the current pen and, if the pen is a geometric pen, the current brush.
									If LineTo succeeds, the current position is set to the specified ending point.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Number: HANDLE
						Number: INT
						Number: INT
				Function: MoveToEx
					Description:
						! 
								The MoveToEx function updates the current position to the specified point and optionally returns the previous position. 
								
								BOOL MoveToEx(
								
									HDC hdc,		// handle of device context
									int X,		// x-coordinate of new current position
									int Y,		// y-coordinate of new current position
									LPPOINT lpPoint	// address of old current position
								);
								
								Parameters
									hdc	Identifies a device context.
									X	Specifies the x-coordinate of the new position, in logical units.
									Y	Specifies the y-coordinate of the new position, in logical units.
									lpPoint	Points to a POINT structure in which the previous current position is stored. If this parameter is a NULL pointer, the previous
										position is not returned. 
								
								Return Values
									If the function succeeds, the return value is nonzero.
									If the function fails, the return value is zero.
								
								Remarks
									The MoveToEx function affects all drawing functions.
								
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Number: HANDLE
						Number: INT
						Number: INT
						structPointer
							Receive Number: LONG
							Receive Number: LONG
				Function: SelectObject
					Description:
						! 
								Selects an object into the given device context.  The new object replaces the previous object of the same type.
								
								HGDIOBJ SelectObject(
								
									HDC hdc,			// handle of device context
									HGDIOBJ hgdiobj		// handle of object
								); 
								
								Parameters:
									hDC		Identifies the device context
									hGDIObj		Identifies the object to be selected.
								
								Return Value:
									The return value is the handle of the object being replaced.
								
								Remarks:
									This function returns the previously selected object of the specified type. 
									An application should always replace a new object with the original, default object after it has finished drawing with the new object. 
									An application cannot select a bitmap into more than one device context at a time. 
					Export Ordinal: 0
					Returns
						Number: HANDLE
					Parameters
						Number: HANDLE
						Number: HANDLE
		Constants
.data CCDATA
0000: 3000000000000000 0000000000000000 00000000
.enddata
.data CCSIZE
0000: 1400
.enddata
			System
				!
				Number: COLOR_BTNFACE			= 15
					! Face color for three-dimensional display elements.
				Number: COLOR_BTNSHADOW		= 16
					! Shadow color for three-dimensional display elements (for edges facing away from the light source).
				Number: COLOR_3DFACE			= COLOR_BTNFACE
					! Face color for three-dimensional display elements.
				Number: COLOR_3DSHADOW		= COLOR_BTNSHADOW
					! Shadow color for three-dimensional display elements (for edges facing away from the light source).
				!
				Number: GW_CHILD			= 5
					! The retrieved handle identifies the child window at the top of the Z order, if the specified window is a parent window; otherwise, the retrieved handle is NULL.
							The function examines only child windows of the specified window. It does not examine descendant windows.
				!
				Number: GWL_STYLE			= -16
					! Retrieves the window styles.
				!
				Number: PS_SOLID				= 0
					! Pen is solid.
				!
				Number: ES_READONLY			= 0x0800
					! Prevents the user from typing or editing text in the edit control.
				!
				Number: WM_GETFONT			= 0x0031
					! An application sends a WM_GETFONT message to a control to retrieve the font with which the control is currently drawing its text. 
							
							WM_GETFONT 
								wParam	= 0;	// not used, must be zero 
								lParam	= 0;	// not used, must be zero 
							 
							Parameters
								This message has no parameters. 
							
							Return Values
								The return value is the handle of the font used by the control, or NULL if the control is using the system font.
							
				Number: WM_COMMAND			= 0x0111
					! The WM_COMMAND message is sent when the user selects a command item from a menu, when a control sends a notification message to its parent window,
							or when an accelerator keystroke is translated.
							
							WM_COMMAND
							
								wNotifyCode	= HIWORD(wParam);	// notification code
								wID		= LOWORD(wParam);	// item, control, or accelerator identifier
								hwndCtl		= (HWND) lParam;		// handle of control
							
							Parameters
								wNotifyCode	Value of the high-order word of wParam. Specifies the notification code if the message is from a control. If the message is from
										an accelerator, this parameter is 1. If the message is from a menu, this parameter is 0.
								wID		Value of the low-order word of wParam. Specifies the identifier of the menu item, control, or accelerator.
								hwndCtl		Value of lParam. Handle to the control sending the message if the message is from a control. Otherwise, this parameter is NULL.
							
							Return Values
								If an application processes this message, it should return zero.
							
							Remarks
								Accelerator keystrokes that select items from the window menu are translated into WM_SYSCOMMAND messages.
							
								If an accelerator keystroke occurs that corresponds to a menu item when the window that owns the menu is minimized, no WM_COMMAND message
								is sent. However, if an accelerator keystroke occurs that does not match any of the items in the window's menu or in the window menu, a
								WM_COMMAND message is sent, even if the window is minimized.
							
								If an application enables a menu separator, the system sends a WM_COMMAND message with the low-word of the wParam parameter set to zero when
								the user selects the separator.
							
							QuickInfo
								Windows NT:	Requires version 3.1 or later.
								Windows:		Requires Windows 95 or later.
								Windows CE:	Requires version 1.0 or later.
								Header:		Declared in winuser.h.
							
				!
				Number: STN_DBLCLK			= 1
					! The STN_DBLCLK notification message is sent when the user double-clicks a static control that has the SS_NOTIFY style.
							The parent window of the control receives this notification message through the WM_COMMAND message.
							
							STN_DBLCLK
							
								idStatic		= ( int )		LOWORD( wParam );	// identifier of static control
								hwndStatic	= ( HWND )	LOWORD( lParam );	// handle to static control 
							 
							QuickInfo
								Windows NT:	Requires version 4.0 or later.
								Windows:		Requires Windows 95 or later.
								Windows CE:	Unsupported.
								Header:		Declared in winuser.h.
							
							
			User
				Number: gc_nMAX_CARETWIDTH		= 10
				Number: gc_nMIN_CARETBR		= 100
				Number: gc_nMAX_CARETBR		= 1000
		Resources
		Variables
.data RESOURCE 0 0 1 978785135
0000: 1E00000011000000 0000000000000000 0200000100000004 000000E0010D0000
0020: 00FF3F
.enddata
		Internal Functions
		Named Menus
		Class Definitions
.data RESOURCE 0 0 1 1696284548
0000: A200000061000000 0000000000000000 0200000100FFFF01 00160000436C6173
0020: 73566172004F7574 6C696E6552006567 496E666F34003C00 000B430047774479
0040: 6E4361720065746C 00000004003C0000 010DF8000000FF4F 0D0000EE0100FF3F
0060: 1A00B800000100FF FFE02700000001FE 00FF03
.enddata
			General Window Class: CGwDynCaret
				Description:
				Derived From
				Class Variables
					Number: __cv_nCaretW
					Number: __cv_hBmp
					Number: __cv_nColor
					Boolean: __cv_bUseBmp
				Instance Variables
				Functions
					Function: On_SAM_Create
						Description:
						Returns
						Parameters
							Number: p_nWParam
							Number: p_nLParam
						Static Variables
						Local variables
						Actions
							If Not __cv_nCaretW
								Set __cv_nCaretW	= 1
					Function: On_SAM_KillFocus
						Description:
						Returns
						Parameters
							Number: p_nWParam
							Number: p_nLParam
						Static Variables
						Local variables
						Actions
							Call DestroyCaret( )
							!
							If __cv_hBmp
								Call DeleteObject( __cv_hBmp )
					Function: On_SAM_SetFocus
						Description:
						Returns
						Parameters
							Number: p_nWParam
							Number: p_nLParam
						Static Variables
						Local variables
							Number: nAveChW
							Number: nHeight
							Number: nTmp
							Number: nRed
							Number: nGreen
							Number: nBlue
							Number: hDC
							Number: hDCC
							Number: hOldPen
							Number: nIndex
							Number: nColor
							Window Handle: hWndEdit
						Actions
							Set hWndEdit	= __cfGetEditField( )
							!
							If hWndEdit
								Call HideCaret( hWndEdit )
								Set hDC		= GetDC( hWndEdit )
								Call SelectObject( hDC, SalSendMsg( hWndEdit, WM_GETFONT, 0, 0 ) )
								Call GetTextMetricsA( hDC, nHeight, nTmp, nTmp, nTmp, nTmp, nAveChW, nTmp, nTmp, nTmp, nTmp, nTmp, nTmp, nTmp, nTmp, nTmp, nTmp, nTmp, nTmp, nTmp, nTmp )
								!
								If __cv_bUseBmp
									Set nIndex	= 0
									Set hDCC		= CreateCompatibleDC( hDC )
									Set __cv_hBmp	= CreateCompatibleBitmap( hDC, nAveChW, nHeight )
									Call SelectObject( hDCC, __cv_hBmp )
									!
									While nIndex < nAveChW
										Call SalColorToRGB( __cv_nColor, nRed, nGreen, nBlue )
										Set hOldPen	= SelectObject( hDCC, CreatePen( PS_SOLID, 1, SalColorFromRGB( nRed / ( nIndex + 1 ), nGreen / ( nIndex + 1 ), nBlue / ( nIndex + 1 ) ) ) )
										Call MoveToEx( hDCC, nIndex, 0, nTmp, nTmp )
										Call LineTo( hDCC, nIndex, nHeight )
										Call DeleteObject( SelectObject( hDCC, hOldPen ) )
										Set nIndex	= nIndex + 1
									!
									Call DeleteDC( hDCC )
								!
								Call ReleaseDC( hWndEdit, hDC )
								!
								If nHeight
									Call CreateCaret( hWndEdit, __cv_hBmp, __cv_nCaretW, nHeight )
								!
								Call ShowCaret( hWndEdit )
					!
					Function: cfSetCaretWidth
						Description:
						Returns
							Boolean:
						Parameters
							Number: p_nNewW
						Static Variables
						Local variables
							String: s
						Actions
							If p_nNewW > 0 And p_nNewW < gc_nMAX_CARETWIDTH
								Set __cv_nCaretW	= p_nNewW
								!
								If SalWindowIsDerivedFromClass( SalGetFocus( ), CGwDynCaret )
									Call On_SAM_SetFocus( SalWindowHandleToNumber( hWndItem ), 0 )
								!
								Return TRUE
							!
							Return FALSE
					Function: cfSetGradientCaret
						Description:
						Returns
							Boolean:
						Parameters
							Boolean: p_bSet
							Number: p_nColor
						Static Variables
						Local variables
							Window Handle: hWndEdit
							Number: nR
							Number: nG
							Number: nB
						Actions
							If Not __cv_hBmp And Not p_bSet
								Set __cv_bUseBmp	= FALSE
								!
								Return TRUE
							!
							If __cv_hBmp And p_bSet
								Call DeleteObject( __cv_hBmp )
								Set __cv_hBmp	= NUMBER_Null
							!
							Set hWndEdit	= __cfGetEditField( )
							!
							If p_bSet
								Call SalColorToRGB( p_nColor, nR, nG, nB )
								Set __cv_nColor	= SalColorFromRGB( 0xFF - nR, 0xFF - nG, 0xFF - nB )
							Else
								Call DeleteObject( __cv_hBmp )
								Set __cv_hBmp	= NUMBER_Null
							!
							Set __cv_bUseBmp		= p_bSet
							!
							If SalWindowIsDerivedFromClass( SalGetFocus( ), CGwDynCaret )
								Call On_SAM_SetFocus( SalWindowHandleToNumber( hWndItem ), 0 )
							!
							Return TRUE
					!
					Function: __cfGetEditField
						Description:
						Returns
							Window Handle:
						Parameters
						Static Variables
						Local variables
						Actions
							Select Case SalGetType( hWndItem )
								Case TYPE_DataField
								Case TYPE_MultilineText
									If VisWinGetFlags( hWndItem ) & WF_DisplayOnly
										Return hWndItem
									!
									If GetWindowLongA( hWndItem, GWL_STYLE ) & ES_READONLY
										If SalGetType( hWndItem ) = TYPE_MultilineText
											Return hWndItem
									Else
										Return hWndItem
									!
									Break
								Case TYPE_ComboBox
									Return GetWindow( hWndItem, GW_CHILD )
							!
							Return hWndNULL
				Message Actions
					On SAM_Create
						Call On_SAM_Create( wParam, lParam )
					On SAM_KillFocus
						Call On_SAM_KillFocus( wParam, lParam )
					On SAM_SetFocus
						Call On_SAM_SetFocus( wParam, lParam )
			Data Field Class: CDfDynCaret
				Data
					Maximum Data Length: Class Default
					Data Type: Class Default
					Editable? Class Default
				Display Settings
					Window Location and Size
						Left:
						Top:   
						Width:  Class Default
						Width Editable? Class Default
						Height: Class Default
						Height Editable? Class Default
					Visible? Class Default
					Border? Class Default
					Justify: Class Default
					Format: Class Default
					Country: Class Default
					Font Name: Class Default
					Font Size: Class Default
					Font Enhancement: Class Default
					Text Color: Class Default
					Background Color: Class Default
					Input Mask: Class Default
				List in Tool Palette? Yes
				Property Template:
				Class DLL Name:
				Description:
				Derived From
					Class: CGwDynCaret
				Class Variables
				Instance Variables
				Functions
				Message Actions
			Multiline Field Class: CMlDynCaret
				Data
					Maximum Data Length: Class Default
					String Type: Class Default
					Editable? Class Default
				Display Settings
					Border? Class Default
					Word Wrap? Class Default
					Vertical Scroll? Class Default
					Window Location and Size
						Left:
						Top:   
						Width:  Class Default
						Width Editable? Class Default
						Height: Class Default
						Height Editable? Class Default
					Visible? Class Default
					Font Name: Class Default
					Font Size: Class Default
					Font Enhancement: Class Default
					Text Color: Class Default
					Background Color: Class Default
				List in Tool Palette? Yes
				Property Template:
				Class DLL Name:
				Description:
				Derived From
					Class: CGwDynCaret
				Class Variables
				Instance Variables
				Functions
				Message Actions
			Combo Box Class: CCmbDynCaret
				Window Location and Size
					Left:
					Top:   
					Width:  Class Default
					Width Editable? Class Default
					Height: Class Default
					Height Editable? Class Default
				Visible? Class Default
				Editable? Class Default
				String Type: Class Default
				Maximum Data Length: Class Default
				Sorted? Class Default
				Always Show List? Class Default
				Vertical Scroll? Class Default
				Font Name: Class Default
				Font Size: Class Default
				Font Enhancement: Class Default
				Text Color: Class Default
				Background Color: Class Default
				Input Mask: Class Default
				List in Tool Palette? Yes
				Property Template:
				Class DLL Name:
				Description:
				Derived From
					Class: CGwDynCaret
				Class Variables
				Instance Variables
				Functions
				List Initialization
				Message Actions
		Default Classes
			MDI Window: cBaseMDI
			Form Window:
			Dialog Box:
			Table Window:
			Quest Window:
			Data Field:
			Spin Field:
			Multiline Field:
			Pushbutton:
			Radio Button:
			Option Button:
			Check Box:
			Child Table:
			Quest Child Window: cQuickDatabase
			List Box:
			Combo Box:
			Picture:
			Vertical Scroll Bar:
			Horizontal Scroll Bar:
			Column:
			Background Text:
			Group Box:
			Line:
			Frame:
			Custom Control:
			ActiveX:
		Application Actions
	!
	Form Window: frmTestCaret
		Class:
		Property Template:
		Class DLL Name:
		Title: Caret sample
		Icon File:
		Accesories Enabled? No
		Visible? Yes
		Display Settings
			Display Style? Default
			Visible at Design time? Yes
			Automatically Created at Runtime? Yes
			Initial State: Normal
			Maximizable? No
			Minimizable? No
			System Menu? Yes
			Resizable? No
			Window Location and Size
				Left: Default
				Top:    Default
				Width:  9.7"
				Width Editable? Yes
				Height: 6.607"
				Height Editable? Yes
			Form Size
				Width:  Default
				Height: Default
				Number of Pages: Dynamic
			Font Name: Default
			Font Size: Default
			Font Enhancement: Default
			Text Color: Default
			Background Color: Default
		Description:
		Named Menus
		Menu
		Tool Bar
			Display Settings
				Display Style? Default
				Location? Top
				Visible? Yes
				Size: Default
				Size Editable? Yes
				Font Name: Default
				Font Size: Default
				Font Enhancement: Default
				Text Color: Default
				Background Color: Default
			Contents
		Contents
			Custom Control: ccNormal
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Property Template:
				Class DLL Name:
				Display Settings
					DLL Name: user32.dll
					MS Windows Class Name: BUTTON
					Style:  0x00000007
					ExStyle:  0x00000000
					Title: Test fields
					Window Location and Size
						Left: 0.45"
						Top:    1.345"
						Width:  4.15"
						Width Editable? Yes
						Height: 1.44"
						Height Editable? Yes
					Visible? Yes
					Border? No
					Etched Border? No
					Hollow? Yes
					Vertical Scroll? No
					Horizontal Scroll? No
					Tab Stop? None
					Tile To Parent? No
					Font Name: Default
					Font Size: Default
					Font Enhancement: Default
					Text Color: Purple
					Background Color: Default
					DLL Settings
				Message Actions
			Combo Box: cmbTest
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class: CCmbDynCaret
				Property Template:
				Class DLL Name:
				Window Location and Size
					Left: 0.633"
					Top:    1.583"
					Width:  3.783"
					Width Editable? Class Default
					Height: 2.44"
					Height Editable? Class Default
				Visible? Class Default
				Editable? Class Default
				String Type: Class Default
				Maximum Data Length: Class Default
				Sorted? Class Default
				Always Show List? Class Default
				Vertical Scroll? Class Default
				Font Name: Class Default
				Font Size: Class Default
				Font Enhancement: Class Default
				Text Color: Class Default
				Background Color: Class Default
				Input Mask: Class Default
				List Initialization
				Message Actions
			Data Field: dfTest
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class: CDfDynCaret
				Property Template:
				Class DLL Name:
				Data
					Maximum Data Length: Class Default
					Data Type: Class Default
					Editable? Class Default
				Display Settings
					Window Location and Size
						Left: 0.617"
						Top:    1.857"
						Width:  3.55"
						Width Editable? Class Default
						Height: 0.25"
						Height Editable? Class Default
					Visible? Class Default
					Border? Class Default
					Justify: Class Default
					Format: Class Default
					Country: Class Default
					Font Name: Class Default
					Font Size: Class Default
					Font Enhancement: Class Default
					Text Color: Class Default
					Background Color: Class Default
					Input Mask: Class Default
				Message Actions
			Multiline Field: mlTest
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class: CMlDynCaret
				Property Template:
				Class DLL Name:
				Data
					Maximum Data Length: 1024
					String Type: Long String
					Editable? Class Default
				Display Settings
					Border? Class Default
					Word Wrap? Yes
					Vertical Scroll? Class Default
					Window Location and Size
						Left: 0.617"
						Top:    2.119"
						Width:  3.817"
						Width Editable? Class Default
						Height: 0.571"
						Height Editable? Class Default
					Visible? Class Default
					Font Name: Class Default
					Font Size: Class Default
					Font Enhancement: Class Default
					Text Color: Class Default
					Background Color: Class Default
				Message Actions
			!
			Custom Control: ccCDTDisabled
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Property Template:
				Class DLL Name:
				Display Settings
					DLL Name: user32.dll
					MS Windows Class Name: BUTTON
					Style:  0x00000007
					ExStyle:  0x00000000
					Title: CDT disabled fields
					Window Location and Size
						Left: 0.45"
						Top:    2.917"
						Width:  4.15"
						Width Editable? Yes
						Height: 1.44"
						Height Editable? Yes
					Visible? Yes
					Border? No
					Etched Border? No
					Hollow? Yes
					Vertical Scroll? No
					Horizontal Scroll? No
					Tab Stop? None
					Tile To Parent? No
					Font Name: Default
					Font Size: Default
					Font Enhancement: Default
					Text Color: Purple
					Background Color: Default
					DLL Settings
				Message Actions
			Combo Box: cmbTestDis
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class: CCmbDynCaret
				Property Template:
				Class DLL Name:
				Window Location and Size
					Left: 0.633"
					Top:    3.167"
					Width:  3.783"
					Width Editable? Class Default
					Height: 2.286"
					Height Editable? Class Default
				Visible? Class Default
				Editable? Class Default
				String Type: Class Default
				Maximum Data Length: Class Default
				Sorted? Class Default
				Always Show List? Class Default
				Vertical Scroll? Class Default
				Font Name: Class Default
				Font Size: Class Default
				Font Enhancement: Class Default
				Text Color: Class Default
				Background Color: Class Default
				Input Mask: Class Default
				List Initialization
				Message Actions
					On SAM_Create
						Call SalDisableWindow( hWndItem )
			Data Field: dfTestDis
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class: CDfDynCaret
				Property Template:
				Class DLL Name:
				Data
					Maximum Data Length: Class Default
					Data Type: Class Default
					Editable? Class Default
				Display Settings
					Window Location and Size
						Left: 0.617"
						Top:    3.44"
						Width:  3.55"
						Width Editable? Class Default
						Height: 0.25"
						Height Editable? Class Default
					Visible? Class Default
					Border? Class Default
					Justify: Class Default
					Format: Class Default
					Country: Class Default
					Font Name: Class Default
					Font Size: Class Default
					Font Enhancement: Class Default
					Text Color: Class Default
					Background Color: Class Default
					Input Mask: Class Default
				Message Actions
					On SAM_Create
						Call SalDisableWindow( hWndItem )
			Multiline Field: mlTestDis
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class: CMlDynCaret
				Property Template:
				Class DLL Name:
				Data
					Maximum Data Length: 1024
					String Type: Long String
					Editable? Class Default
				Display Settings
					Border? Class Default
					Word Wrap? Yes
					Vertical Scroll? Class Default
					Window Location and Size
						Left: 0.617"
						Top:    3.702"
						Width:  3.817"
						Width Editable? Class Default
						Height: 0.571"
						Height Editable? Class Default
					Visible? Class Default
					Font Name: Class Default
					Font Size: Class Default
					Font Enhancement: Class Default
					Text Color: Class Default
					Background Color: Class Default
				Message Actions
					On SAM_Create
						Call SalDisableWindow( hWndItem )
			!
			Custom Control: ccCDTReadOnly
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Property Template:
				Class DLL Name:
				Display Settings
					DLL Name: user32.dll
					MS Windows Class Name: BUTTON
					Style:  0x00000007
					ExStyle:  0x00000000
					Title: CDT non-editable fields
					Window Location and Size
						Left: 0.45"
						Top:    4.524"
						Width:  4.15"
						Width Editable? Yes
						Height: 1.44"
						Height Editable? Yes
					Visible? Yes
					Border? No
					Etched Border? No
					Hollow? Yes
					Vertical Scroll? No
					Horizontal Scroll? No
					Tab Stop? None
					Tile To Parent? No
					Font Name: Default
					Font Size: Default
					Font Enhancement: Default
					Text Color: Purple
					Background Color: Default
					DLL Settings
				Message Actions
			Combo Box: cmbTestCTDRo
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class: CCmbDynCaret
				Property Template:
				Class DLL Name:
				Window Location and Size
					Left: 0.633"
					Top:    4.774"
					Width:  3.783"
					Width Editable? Class Default
					Height: 2.131"
					Height Editable? Class Default
				Visible? Class Default
				Editable? No
				String Type: Class Default
				Maximum Data Length: Class Default
				Sorted? Class Default
				Always Show List? Class Default
				Vertical Scroll? Class Default
				Font Name: Class Default
				Font Size: Class Default
				Font Enhancement: Class Default
				Text Color: Class Default
				Background Color: Class Default
				Input Mask: Class Default
				List Initialization
				Message Actions
			Data Field: dfTestCTDRo
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class: CDfDynCaret
				Property Template:
				Class DLL Name:
				Data
					Maximum Data Length: Class Default
					Data Type: Class Default
					Editable? No
				Display Settings
					Window Location and Size
						Left: 0.617"
						Top:    5.048"
						Width:  3.55"
						Width Editable? Class Default
						Height: 0.25"
						Height Editable? Class Default
					Visible? Class Default
					Border? Class Default
					Justify: Class Default
					Format: Class Default
					Country: Class Default
					Font Name: Class Default
					Font Size: Class Default
					Font Enhancement: Class Default
					Text Color: Class Default
					Background Color: Class Default
					Input Mask: Class Default
				Message Actions
			Multiline Field: mlTestCTDRo
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class: CMlDynCaret
				Property Template:
				Class DLL Name:
				Data
					Maximum Data Length: 1024
					String Type: Long String
					Editable? No
				Display Settings
					Border? Class Default
					Word Wrap? Yes
					Vertical Scroll? Class Default
					Window Location and Size
						Left: 0.617"
						Top:    5.31"
						Width:  3.817"
						Width Editable? Class Default
						Height: 0.571"
						Height Editable? Class Default
					Visible? Class Default
					Font Name: Class Default
					Font Size: Class Default
					Font Enhancement: Class Default
					Text Color: Class Default
					Background Color: Class Default
				Message Actions
			!
			Custom Control: ccAdjustCaretW
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Property Template:
				Class DLL Name:
				Display Settings
					DLL Name: user32.dll
					MS Windows Class Name: BUTTON
					Style:  0x00000007
					ExStyle:  0x00000000
					Title: Adjust caret
					Window Location and Size
						Left: 0.45"
						Top:    0.345"
						Width:  8.617"
						Width Editable? Yes
						Height: 0.869"
						Height Editable? Yes
					Visible? Yes
					Border? No
					Etched Border? No
					Hollow? Yes
					Vertical Scroll? No
					Horizontal Scroll? No
					Tab Stop? None
					Tile To Parent? No
					Font Name: Default
					Font Size: Default
					Font Enhancement: Default
					Text Color: Purple
					Background Color: Default
					DLL Settings
				Message Actions
			Background Text: Caret blink rate
				Resource Id: 57308
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Window Location and Size
					Left: 0.617"
					Top:    0.631"
					Width:  1.817"
					Width Editable? Yes
					Height: 0.167"
					Height Editable? Yes
				Visible? Yes
				Justify: Left
				Font Name: Default
				Font Size: Default
				Font Enhancement: Default
				Text Color: Default
				Background Color: Default
			Horizontal Scroll Bar: hsbBlinkRate
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Property Template:
				Class DLL Name:
				Window Location and Size
					Left: 2.517"
					Top:    0.607"
					Width:  2.0"
					Width Editable? Yes
					Height: 0.214"
					Height Editable? Yes
				Visible? Yes
				Message Actions
					On SAM_Create
						Call SalScrollSetRange( hWndItem, gc_nMIN_CARETBR, gc_nMAX_CARETBR, 1, SalNumberMax( gc_nMAX_CARETBR - gc_nMIN_CARETBR / 10, 1 ) )
						Call SalScrollSetPos( hWndItem, GetCaretBlinkTime( ) )
						Call wfUpdateSample( )
					On SAM_ScrollBar
						Call wfUpdateSample( )
			Data Field: dfBlinkRate
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Property Template:
				Class DLL Name:
				Data
					Maximum Data Length: Default
					Data Type: Number
					Editable? No
				Display Settings
					Window Location and Size
						Left: 3.333"
						Top:    0.917"
						Width:  0.833"
						Width Editable? Yes
						Height: 0.167"
						Height Editable? Yes
					Visible? Yes
					Border? No
					Justify: Right
					Format: Unformatted
					Country: Default
					Font Name: Default
					Font Size: Default
					Font Enhancement: Bold
					Text Color: Blue
					Background Color: 3D Face Color
					Input Mask: Unformatted
				Message Actions
			Background Text: ms
				Resource Id: 57309
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Window Location and Size
					Left: 4.217"
					Top:    0.917"
					Width:  0.3"
					Width Editable? Yes
					Height: 0.167"
					Height Editable? Yes
				Visible? Yes
				Justify: Right
				Font Name: Default
				Font Size: Default
				Font Enhancement: Default
				Text Color: Default
				Background Color: Default
			Background Text: Caret width
				Resource Id: 57306
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Window Location and Size
					Left: 5.067"
					Top:    0.631"
					Width:  1.7"
					Width Editable? Yes
					Height: 0.167"
					Height Editable? Yes
				Visible? Yes
				Justify: Left
				Font Name: Default
				Font Size: Default
				Font Enhancement: Default
				Text Color: Default
				Background Color: Default
			Horizontal Scroll Bar: hsbWidth
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Property Template:
				Class DLL Name:
				Window Location and Size
					Left: 6.8"
					Top:    0.607"
					Width:  1.733"
					Width Editable? Yes
					Height: 0.214"
					Height Editable? Yes
				Visible? Yes
				Message Actions
					On SAM_Create
						Call SalScrollSetRange( hWndItem, 1, gc_nMAX_CARETWIDTH, 1, 1 )
						Call wfUpdateSample( )
					On SAM_ScrollBar
						Call wfUpdateSample( )
			Data Field: dfWidth
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Property Template:
				Class DLL Name:
				Data
					Maximum Data Length: Default
					Data Type: Number
					Editable? No
				Display Settings
					Window Location and Size
						Left: 8.65"
						Top:    0.631"
						Width:  0.267"
						Width Editable? Yes
						Height: 0.167"
						Height Editable? Yes
					Visible? Yes
					Border? No
					Justify: Right
					Format: Unformatted
					Country: Default
					Font Name: Default
					Font Size: Default
					Font Enhancement: Bold
					Text Color: Blue
					Background Color: 3D Face Color
					Input Mask: Unformatted
				Message Actions
			Background Text: Sample caret preview
				Resource Id: 28955
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Window Location and Size
					Left: 0.617"
					Top:    0.917"
					Width:  1.817"
					Width Editable? Yes
					Height: 0.167"
					Height Editable? Yes
				Visible? Yes
				Justify: Left
				Font Name: Default
				Font Size: Default
				Font Enhancement: Default
				Text Color: Default
				Background Color: Default
			Custom Control: ccCaretSample
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Property Template:
				Class DLL Name:
				Display Settings
					DLL Name: user32.dll
					MS Windows Class Name: STATIC
					Style:  0x00000000
					ExStyle:  0x00000000
					Title:
					Window Location and Size
						Left: 2.517"
						Top:    0.917"
						Width:  0.417"
						Width Editable? Yes
						Height: 0.167"
						Height Editable? Yes
					Visible? Yes
					Border? No
					Etched Border? No
					Hollow? No
					Vertical Scroll? No
					Horizontal Scroll? No
					Tab Stop? None
					Tile To Parent? No
					Font Name: Arial
					Font Size: 10
					Font Enhancement: None
					Text Color: Default
					Background Color: Default
					DLL Settings
				Message Actions
			Check Box: cbGradient
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Property Template:
				Class DLL Name:
				Title: Use gradient
				Window Location and Size
					Left: 7.217"
					Top:    0.881"
					Width:  1.7"
					Width Editable? Yes
					Height: 0.25"
					Height Editable? Yes
				Visible? Yes
				Font Name: Default
				Font Size: Default
				Font Enhancement: Default
				Text Color: Default
				Background Color: Default
				Message Actions
					On SAM_Create
						Call SalDisableWindowAndLabel( ccColor )
						Set w_nOldColor	= SalColorGet( ccColor, COLOR_IndexWindow )
					On SAM_Click
						If MyValue
							Call SalInvalidateWindow( ccCaretSample )
							Call SalUpdateWindow( ccCaretSample )
							Call SalDisableWindowAndLabel( hsbWidth )
							Call SalDisableWindowAndLabel( ccCaretSample )
							Call SalColorSet( dfWidth, COLOR_IndexWindowText, COLOR_3DShadow )
							Call SalEnableWindowAndLabel( ccColor )
							Call SalColorSet( ccColor, COLOR_IndexWindow, w_nOldColor )
						Else
							Call SalColorSet( dfWidth, COLOR_IndexWindowText, COLOR_Blue )
							Call SalEnableWindowAndLabel( hsbWidth )
							Call SalEnableWindowAndLabel( ccCaretSample )
							Call SalDisableWindowAndLabel( ccColor )
							Set w_nOldColor	= SalColorGet( ccColor, COLOR_IndexWindow )
							Call SalColorSet( ccColor, COLOR_IndexWindow, COLOR_3DFace )
						!
						Call cmbTestDis.cfSetGradientCaret( MyValue, w_nOldColor )
			Background Text: Gradient caret color
				Resource Id: 57307
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Window Location and Size
					Left: 5.067"
					Top:    0.917"
					Width:  1.7"
					Width Editable? Yes
					Height: 0.167"
					Height Editable? Yes
				Visible? Yes
				Justify: Left
				Font Name: Default
				Font Size: Default
				Font Enhancement: Default
				Text Color: Default
				Background Color: Default
			Custom Control: ccColor
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Property Template:
				Class DLL Name:
				Display Settings
					DLL Name: user32.dll
					MS Windows Class Name: STATIC
					Style:  0x00001101
					ExStyle:  0x00000000
					Title:
					Window Location and Size
						Left: 6.8"
						Top:    0.893"
						Width:  0.35"
						Width Editable? Yes
						Height: 0.214"
						Height Editable? Yes
					Visible? Yes
					Border? No
					Etched Border? No
					Hollow? No
					Vertical Scroll? No
					Horizontal Scroll? No
					Tab Stop? Tab
					Tile To Parent? No
					Font Name: Arial
					Font Size: 10
					Font Enhancement: None
					Text Color: Default
					Background Color: Default
					DLL Settings
				Message Actions
					On SAM_Create
						Call SalDisableWindow( hWndItem )
			!
			Custom Control: ccNormal_VF
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Property Template:
				Class DLL Name:
				Display Settings
					DLL Name: user32.dll
					MS Windows Class Name: BUTTON
					Style:  0x00000007
					ExStyle:  0x00000000
					Title: Test fields - variable fonts
					Window Location and Size
						Left: 4.9"
						Top:    1.345"
						Width:  4.15"
						Width Editable? Yes
						Height: 3.0"
						Height Editable? Yes
					Visible? Yes
					Border? No
					Etched Border? No
					Hollow? Yes
					Vertical Scroll? No
					Horizontal Scroll? No
					Tab Stop? None
					Tile To Parent? No
					Font Name: Default
					Font Size: Default
					Font Enhancement: Default
					Text Color: Purple
					Background Color: Default
					DLL Settings
				Message Actions
			Combo Box: cmbTest_VF
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class: CCmbDynCaret
				Property Template:
				Class DLL Name:
				Window Location and Size
					Left: 5.083"
					Top:    1.655"
					Width:  3.783"
					Width Editable? Class Default
					Height: 2.619"
					Height Editable? Class Default
				Visible? Class Default
				Editable? Class Default
				String Type: Class Default
				Maximum Data Length: Class Default
				Sorted? Class Default
				Always Show List? Class Default
				Vertical Scroll? Class Default
				Font Name: Algerian
				Font Size: 14
				Font Enhancement: Underline
				Text Color: Dark Green
				Background Color: Class Default
				Input Mask: Class Default
				List Initialization
				Message Actions
			Data Field: dfTest_VF
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class: CDfDynCaret
				Property Template:
				Class DLL Name:
				Data
					Maximum Data Length: Class Default
					Data Type: Class Default
					Editable? Class Default
				Display Settings
					Window Location and Size
						Left: 5.067"
						Top:    2.036"
						Width:  3.55"
						Width Editable? Class Default
						Height: 0.571"
						Height Editable? Class Default
					Visible? Class Default
					Border? Class Default
					Justify: Class Default
					Format: Class Default
					Country: Class Default
					Font Name: Tahoma
					Font Size: 24
					Font Enhancement: Bold-Underline
					Text Color: Dark Blue
					Background Color: Class Default
					Input Mask: Class Default
				Message Actions
			Multiline Field: mlTest_VF
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class: CMlDynCaret
				Property Template:
				Class DLL Name:
				Data
					Maximum Data Length: 1024
					String Type: Long String
					Editable? Class Default
				Display Settings
					Border? Class Default
					Word Wrap? Yes
					Vertical Scroll? Class Default
					Window Location and Size
						Left: 5.067"
						Top:    2.595"
						Width:  3.817"
						Width Editable? Class Default
						Height: 1.631"
						Height Editable? Class Default
					Visible? Class Default
					Font Name: Times New Roman
					Font Size: 20
					Font Enhancement: Italic
					Text Color: Marigold
					Background Color: Class Default
				Message Actions
			!
			Custom Control: ccVTReadOnly
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class:
				Property Template:
				Class DLL Name:
				Display Settings
					DLL Name: user32.dll
					MS Windows Class Name: BUTTON
					Style:  0x00000007
					ExStyle:  0x00000000
					Title: VT non-editable fields
					Window Location and Size
						Left: 4.9"
						Top:    4.524"
						Width:  4.15"
						Width Editable? Yes
						Height: 1.44"
						Height Editable? Yes
					Visible? Yes
					Border? No
					Etched Border? No
					Hollow? Yes
					Vertical Scroll? No
					Horizontal Scroll? No
					Tab Stop? None
					Tile To Parent? No
					Font Name: Default
					Font Size: Default
					Font Enhancement: Default
					Text Color: Purple
					Background Color: Default
					DLL Settings
				Message Actions
			Combo Box: cmbTestEnVTRo
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class: CCmbDynCaret
				Property Template:
				Class DLL Name:
				Window Location and Size
					Left: 5.083"
					Top:    4.774"
					Width:  3.783"
					Width Editable? Class Default
					Height: 1.976"
					Height Editable? Class Default
				Visible? Class Default
				Editable? Class Default
				String Type: Class Default
				Maximum Data Length: Class Default
				Sorted? Class Default
				Always Show List? Class Default
				Vertical Scroll? Class Default
				Font Name: Class Default
				Font Size: Class Default
				Font Enhancement: Class Default
				Text Color: Class Default
				Background Color: Class Default
				Input Mask: Class Default
				List Initialization
				Message Actions
					On SAM_Create
						Call VisWinSetFlags( hWndItem, WF_DisplayOnly, TRUE )
			Data Field: dfTestEnRoVTRo
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class: CDfDynCaret
				Property Template:
				Class DLL Name:
				Data
					Maximum Data Length: Class Default
					Data Type: Class Default
					Editable? Class Default
				Display Settings
					Window Location and Size
						Left: 5.067"
						Top:    5.048"
						Width:  3.55"
						Width Editable? Class Default
						Height: 0.25"
						Height Editable? Class Default
					Visible? Class Default
					Border? Class Default
					Justify: Class Default
					Format: Class Default
					Country: Class Default
					Font Name: Class Default
					Font Size: Class Default
					Font Enhancement: Class Default
					Text Color: Class Default
					Background Color: Class Default
					Input Mask: Class Default
				Message Actions
					On SAM_Create
						Call VisWinSetFlags( hWndItem, WF_DisplayOnly, TRUE )
			Multiline Field: mlTestEnRoVTRo
				Class Child Ref Key: 0
				Class ChildKey: 0
				Class: CMlDynCaret
				Property Template:
				Class DLL Name:
				Data
					Maximum Data Length: 1024
					String Type: Long String
					Editable? Class Default
				Display Settings
					Border? Class Default
					Word Wrap? Yes
					Vertical Scroll? Class Default
					Window Location and Size
						Left: 5.067"
						Top:    5.31"
						Width:  3.817"
						Width Editable? Class Default
						Height: 0.571"
						Height Editable? Class Default
					Visible? Class Default
					Font Name: Class Default
					Font Size: Class Default
					Font Enhancement: Class Default
					Text Color: Class Default
					Background Color: Class Default
				Message Actions
					On SAM_Create
						Call VisWinSetFlags( hWndItem, WF_DisplayOnly, TRUE )
		Functions
			Function: On_SAM_Create
				Description:
				Returns
				Parameters
					Number: p_nWParam
					Number: p_nLParam
				Static Variables
				Local variables
				Actions
					Set w_nOldWidth	= 1
					Set w_nOldBR	= GetCaretBlinkTime( )
					Call SalTimerSet( hWndForm, 1, w_nOldBR )
			Function: On_SAM_Destroy
				Description:
				Returns
				Parameters
					Number: p_nWParam
					Number: p_nLParam
				Static Variables
				Local variables
				Actions
					Call SetCaretBlinkTime( w_nOldBR )
			Function: On_SAM_Activate
				Description:
				Returns
				Parameters
					Number: p_nWParam
					Number: p_nLParam
				Static Variables
				Local variables
				Actions
					If wParam
						Call SetCaretBlinkTime( dfBlinkRate )
					Else
						Call SetCaretBlinkTime( w_nOldBR )
			Function: On_SAM_Timer
				Description:
				Returns
				Parameters
					Number: p_nWParam
					Number: p_nLParam
				Static Variables
					Boolean: bOn
				Local variables
					Number: hDC
					Number: nL
					Number: nT
					Number: nR
					Number: nB
					Number: hBr
				Actions
					If Not cbGradient
						Call GetClientRect( ccCaretSample, nL, nT, nR, nB )
						!
						Set hDC		= GetDC( ccCaretSample )
						!
						If Not bOn
							Set hBr	= CreateSolidBrush( GetSysColor( COLOR_3DFACE ) )
							Call FillRect( hDC, ( nL + nR - w_nOldWidth ) / 2, nT, ( nL + nR + w_nOldWidth ) / 2, nB, hBr )
							Set w_nOldWidth	= dfWidth
						Else
							Set hBr	= CreateSolidBrush( GetSysColor( COLOR_3DSHADOW ) )
							Call FillRect( hDC, ( nL + nR - w_nOldWidth ) / 2, nT, ( nL + nR + w_nOldWidth ) / 2, nB, hBr )
						!
						Call DeleteObject( hBr )
						Call ReleaseDC( ccCaretSample, hDC )
						!
						Set bOn		= Not bOn
			!
			Function: On_WM_Command
				Description:
				Returns
				Parameters
					Number: p_nWParam
					Number: p_nLParam
				Static Variables
				Local variables
					Window Handle: hWnd
					Number: nColor
				Actions
					If SalNumberHigh( wParam ) = STN_DBLCLK
						Set hWnd	= SalNumberToWindowHandle( lParam )
						!
						If hWnd = ccColor
							If SalDlgChooseColor( hWndForm, nColor )
								Call SalColorSet( hWnd, COLOR_IndexWindow, nColor )
								Call cmbTestDis.cfSetGradientCaret( cbGradient, nColor )
								Call SalSetFocus( ccColor )
			!
			Function: wfUpdateSample
				Description:
				Returns
				Parameters
				Static Variables
				Local variables
				Actions
					Call SalScrollGetPos( hsbWidth, dfWidth )
					Call cmbTest.cfSetCaretWidth( dfWidth )
					Call SalScrollGetPos( hsbBlinkRate, dfBlinkRate )
					Call SetCaretBlinkTime( dfBlinkRate )
					Call SalTimerKill( hWndForm, 1 )
					Call SalTimerSet( hWndForm, 1, dfBlinkRate )
		Window Parameters
		Window Variables
			Number: w_nOldWidth
			Number: w_nOldColor
			Number: w_nOldBR
		Message Actions
			On SAM_Activate
				Call On_SAM_Activate( wParam, lParam )
			On SAM_Create
				Call On_SAM_Create( wParam, lParam )
			On SAM_Destroy
				Call On_SAM_Destroy( wParam, lParam )
			On SAM_Timer
				Call On_SAM_Timer( wParam, lParam )
			!
			On WM_COMMAND
				Call On_WM_Command( wParam, lParam )
